package com.dzdy.dim.handler;


import com.dzdy.dim.NettyClient;
import com.dzdy.dim.protocol.response.LoginResponsePacket;
import com.dzdy.dim.util.SessionUtil;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;

import static com.dzdy.dim.NettyClient.MAX_RETRY;

/**
 * 登录返回处理器
 *
 * @author : wangzhiyong
 * @date : 2019/5/28 17:40
 * description :
 */
public class LoginResponseHandler extends SimpleChannelInboundHandler<LoginResponsePacket> {
    @Override
    protected void channelRead0(ChannelHandlerContext ctx, LoginResponsePacket packet) {
        if (packet.isSuccess()) {
            System.out.println(String.format("[%s]登录成功", packet.getSession().getUserId()));
            SessionUtil.bind(packet.getSession(), ctx.channel());
        } else {
            System.out.println(String.format("登录失败，原因:%s", packet.getReason()));
        }
    }

    @Override
    public void channelInactive(ChannelHandlerContext ctx) {
        System.out.println("客户端连接关闭");
        // todo 服务端断开重连
        NettyClient.connect(MAX_RETRY);
    }
}
