package com.dzdy.dim.contants;

import com.dzdy.dim.util.IDUtil;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

/**
 * 设备 Session
 *
 * @author : wangzhiyong
 * @date : 2019/5/27 13:44
 * description :
 */
@Data
public class Session {

    /**
     * 每个可通信sessionId
     */
    private String sessionId;
    /**
     * 用户id
     */
    private String userId;
    /**
     * 用户名称
     */
    private String userName;

    /**
     * 平台 1 web 2 验货机 3 晨检仪
     */
    private String platform;

    /**
     * 设备标识
     */
    private String imei;

    public static Session buildSession(String userId, String platform, String imei) {
        Session session = new Session();
        session.setSessionId(IDUtil.sessionId());
        session.setUserId(userId);
        session.setPlatform(platform);
        session.setImei(imei);
        return session;
    }

    public static Session buildSession(String userId, String platform) {
        Session session = new Session();
        session.setSessionId(IDUtil.sessionId());
        session.setUserId(userId);
        session.setPlatform(platform);
        return session;
    }
}
