package com.dzdy.dim.handler;

import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.timeout.IdleStateEvent;
import io.netty.handler.timeout.IdleStateHandler;

import java.util.concurrent.TimeUnit;

/**
 * 闲时检测
 *
 * @author : wangzhiyong
 * @date : 2019/5/27 14:18
 * description : 公用handler
 */
public class IMIdleStateHandler extends IdleStateHandler {

    /**
     * 检测间隔
     */
    private static final int READER_IDLE_TIME = 120;

    public IMIdleStateHandler() {
        super(READER_IDLE_TIME, 0, 0, TimeUnit.SECONDS);
    }

    @Override
    protected void channelIdle(ChannelHandlerContext ctx, IdleStateEvent evt) {
        System.out.println(READER_IDLE_TIME + "s 内未读取到数据，关闭连接");
        ctx.channel().close();
    }
}
