package com.dzdy.dim.handler;

import com.dzdy.dim.protocol.Packet;
import com.dzdy.dim.protocol.PacketCode;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.MessageToMessageCodec;

import java.util.List;

/**
 * 拆、粘包
 *
 * @author : wangzhiyong
 * @date : 2019/5/27 14:18
 * description : 公用handler
 */
@ChannelHandler.Sharable
public class PacketCodecHandler extends MessageToMessageCodec<ByteBuf, Packet> {

    public static final PacketCodecHandler INSTANCE = new PacketCodecHandler();

    private PacketCodecHandler() {
    }

    @Override
    protected void encode(ChannelHandlerContext ctx, Packet packet, List<Object> out) throws Exception {
        ByteBuf buffer = ctx.channel().alloc().buffer();
        PacketCode.INSTANCE.encode(buffer, packet);
        out.add(buffer);
    }

    @Override
    protected void decode(ChannelHandlerContext ctx, ByteBuf byteBuf, List<Object> out) throws Exception {
        out.add(PacketCode.INSTANCE.decode(byteBuf));
    }
}
