package com.dzdy.dim.handler;

import com.dzdy.dim.protocol.PacketCode;
import io.netty.buffer.ByteBuf;
import io.netty.channel.ChannelHandlerContext;
import io.netty.handler.codec.LengthFieldBasedFrameDecoder;

/**
 * 协议数据校验 保证数据完整 禁止非法连接
 *
 * @author : wangzhiyong
 * @date : 2019/5/27 14:20
 * description :
 */
public class Spliter extends LengthFieldBasedFrameDecoder {

    /**
     * 长度域偏移量
     */
    private static final int LENGTH_FIELD_OFFSET = 7;
    /**
     * 长度域的长度（4个字节存数据的长度）
     */
    private static final int LENGTH_FIELD_LENGTH = 4;

    public Spliter() {
        super(Integer.MAX_VALUE, LENGTH_FIELD_OFFSET, LENGTH_FIELD_LENGTH);
    }

    @Override
    protected Object decode(ChannelHandlerContext ctx, ByteBuf in) throws Exception {
        if (in.getInt(in.readerIndex()) != PacketCode.MAGIC_NUMBER) {
            ctx.channel().close();
            return null;
        }
        return super.decode(ctx, in);
    }
}
