package com.dzdy.dim.protocol;

import com.dzdy.dim.protocol.command.Command;
import com.dzdy.dim.util.IDUtil;
import lombok.Data;
import lombok.EqualsAndHashCode;

/**
 * sock消息体
 *
 * @author : wangzhiyong
 * @date : 2019/5/25 09:15
 * description :
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class SockData<T> extends Packet {

    /**
     * 通信消息id
     */
    private String id;

    /**
     * 通信数据
     */
    private T data;

    /**
     * 操作指令
     */
    transient private Command command;

    public static <T> SockData<T> newData(Command command, T data) {
        SockData<T> sockData = new SockData<>();
        sockData.setId(IDUtil.messageId());
        sockData.setCommand(command);
        sockData.setData(data);
        return sockData;
    }

    @Override
    public Byte getCommand() {
        return command.getCode();
    }

}
