package com.dzdy.dim.protocol.request;

import com.dzdy.dim.contants.SessionPlatformEnum;
import com.dzdy.dim.protocol.Packet;
import lombok.Data;
import lombok.EqualsAndHashCode;

import static com.dzdy.dim.protocol.command.Command.LOGIN_REQUEST;

/**
 * 登录请求包
 *
 * @author : wangzhiyong
 * @date : 2019/5/28 10:45
 * description :
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class LoginRequestPacket extends Packet {

    /**
     * 授权token
     */
    private String token;

    /**
     * 平台 app
     * {@link SessionPlatformEnum}
     */
    private String platform;

    /**
     * 设备标识
     */
    private String imei;

    @Override
    public Byte getCommand() {
        return LOGIN_REQUEST.getCode();
    }
}
