package com.dzdy.dim.protocol.response;

import com.dzdy.dim.contants.Session;
import com.dzdy.dim.protocol.Packet;
import lombok.Data;
import lombok.EqualsAndHashCode;

import static com.dzdy.dim.protocol.command.Command.LOGIN_RESPONSE;

/**
 * 登录返回包
 *
 * @author : wangzhiyong
 * @date : 2019/5/28 10:49
 * description :
 */
@EqualsAndHashCode(callSuper = true)
@Data
public class LoginResponsePacket extends Packet {

    /**
     * 连接 session 信息
     */
    private Session session;

    /**
     * 登录状态
     */
    private boolean success;
    /**
     * 原因
     */
    private String reason;

    @Override
    public Byte getCommand() {
        return LOGIN_RESPONSE.getCode();
    }
}
