package com.dzdy.dim.serialize;

import com.dzdy.dim.serialize.impl.JSONSerializer;

/**
 * 序列化数据
 *
 * @author : wangzhiyong
 * @date : 2019/5/25 15:22
 * description :
 */
public interface Serializer {

    /**
     * 默认 json序列化
     */
    Serializer DEFAULT = new JSONSerializer();

    /**
     * 序列化算法
     *
     * @return
     */
    byte getSerializerAlgorithm();

    /**
     * java对象 序列化为二进制
     *
     * @param object
     * @return
     */
    byte[] serialize(Object object);


    /**
     * 序列化为字符串
     *
     * @param object
     * @param skipTransientField 是否过滤transient字段
     * @return
     */
    String serialize(Object object, boolean skipTransientField);

    /**
     * 二进制转换成 java对象
     *
     * @param bytes
     * @param clazz
     * @param <T>
     * @return
     */
    <T> T deserialize(byte[] bytes, Class<T> clazz);
}
