package com.dzdy.dim.serialize.impl;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.alibaba.fastjson.serializer.SerializeWriter;
import com.alibaba.fastjson.serializer.SerializerFeature;
import com.dzdy.dim.serialize.Serializer;
import com.dzdy.dim.serialize.SerializerAlgorithm;

/**
 * json 序列化
 *
 * @author : wangzhiyong
 * @date : 2019/5/25 15:30
 * description :
 */
public class JSONSerializer implements Serializer {
    @Override
    public byte getSerializerAlgorithm() {
        return SerializerAlgorithm.JSON;
    }

    @Override
    public byte[] serialize(Object object) {
        return JSONObject.toJSONBytes(object);
    }

    @Override
    public String serialize(Object object, boolean skipTransientField) {
        SerializeWriter out = new SerializeWriter();
        com.alibaba.fastjson.serializer.JSONSerializer serializer = new com.alibaba.fastjson.serializer.JSONSerializer(out);
        serializer.config(SerializerFeature.SkipTransientField, skipTransientField);
        serializer.write(object);
        return out.toString();
    }

    @Override
    public <T> T deserialize(byte[] bytes, Class<T> clazz) {
        return JSON.parseObject(bytes, clazz);
    }
}
