package com.dzdy.dim.api;

import lombok.Data;

import java.io.Serializable;

/**
 * 操作返回
 *
 * @author : wangzhiyong
 * @date : 2019/5/27 15:22
 * description :
 */
@Data
public class R<T> implements Serializable {

    private static final int SUCCESS = 0;
    private static final int FAILED = -1;

    /**
     * 业务错误码
     */
    private long code;
    /**
     * 结果集
     */
    private T data;
    /**
     * 描述
     */
    private String msg;

    public static <T> R<T> ok(T data) {
        if (data instanceof Boolean && Boolean.FALSE.equals(data)) {
            restResult(false, FAILED, "操作失败");
        }
        return restResult(data, SUCCESS, "执行成功");
    }

    public static <T> R<T> failed(String msg) {
        return restResult(null, FAILED, msg);
    }

    private static <T> R<T> restResult(T data, long code, String msg) {
        R<T> apiResult = new R<>();
        apiResult.setCode(code);
        apiResult.setData(data);
        apiResult.setMsg(msg);
        return apiResult;
    }
}
