package com.dzdy.dim.api.impl;

import com.dzdy.dim.api.ClientApi;
import com.dzdy.dim.api.R;
import com.dzdy.dim.contants.Session;
import com.dzdy.dim.protocol.response.LogoutResponsePacket;
import com.dzdy.dim.util.SessionUtil;
import io.netty.channel.Channel;
import lombok.extern.slf4j.Slf4j;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * @author : wangzhiyong
 * @date : 2019/5/27 15:36
 * description :
 */
@Slf4j
@RestController
@RequestMapping("client")
public class ClientApiImpl implements ClientApi {

    @Override
    @GetMapping("getAllSession")
    public R<List<Session>> getAllSession(String userId) {
        List<Session> sessionList = SessionUtil.getSession(userId);
        return R.ok(sessionList);
    }

    @Override
    @DeleteMapping("/userId/{sessionId}")
    public R<Boolean> removeSession(@PathVariable String sessionId) {
        Channel channel = SessionUtil.getChannel(sessionId);
        SessionUtil.unBind(channel);
        LogoutResponsePacket logoutResponsePacket = new LogoutResponsePacket();
        logoutResponsePacket.setSuccess(true);
        channel.writeAndFlush(logoutResponsePacket).addListener(future -> {
            if (future.isSuccess()) {
                log.info("客户端下线成功");
            } else {
                log.info("客户端下线失败:", future.cause());
            }
        });
        return R.ok(true);
    }
}
