package com.dzdy.dim.api.impl;

import com.dzdy.dim.api.PushApi;
import com.dzdy.dim.api.R;
import com.dzdy.dim.contants.PushParam;
import com.dzdy.dim.util.PushUtil;
import com.dzdy.dim.util.SessionUtil;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;

/**
 * 推送消息
 * 异步推送 后续可拓展等待结果
 *
 * @author : wangzhiyong
 * @date : 2019/5/27 15:36
 * description :
 */
@RestController
@RequestMapping("push")
public class PushApiImpl implements PushApi {

    @Override
    @PostMapping("pushBySession")
    public R<Boolean> pushBySession(@Valid @RequestBody PushParam pushParam) {
        pushParam.getSessions().forEach(session -> PushUtil.push(session, pushParam.getCommand(), pushParam.getPushData()));
        return R.ok(true);
    }

    @Override
    @PostMapping("pushByUserId")
    public R<Boolean> pushByUserId(@Valid @RequestBody PushParam pushParam) {
        pushParam.getUserIds().forEach(userId -> SessionUtil.getSession(userId)
                .forEach(session -> PushUtil.push(session, pushParam.getCommand(), pushParam.getPushData())));
        return R.ok(true);
    }
}
