package com.dzdy.dim.contants;

import com.dzdy.dim.protocol.command.Command;
import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;

import javax.validation.constraints.NotNull;
import java.util.List;

/**
 * 推送数据封装类
 *
 * @author : wangzhiyong
 * @date : 2019/6/4 14:25
 * description :
 */
@Data
@NoArgsConstructor
@AllArgsConstructor
public class PushParam {

    /**
     * session 集合
     */
    List<Session> sessions;

    /**
     * 用户id 集合
     */
    List<String> userIds;

    /**
     * 推送数据
     */
    @NotNull(message = "推送数据不能为空")
    Object pushData;

    /**
     * 推送指令
     */
    @NotNull(message = "推送指令不能为空")
    Command command;
}
