package com.dzdy.dim.handler;

import com.dzdy.dim.util.SessionUtil;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;

/**
 * 授权检查处理器
 *
 * @author : wangzhiyong
 * @date : 2019/5/28 14:33
 * description :
 */
@ChannelHandler.Sharable
public class AuthHandler extends ChannelInboundHandlerAdapter {

    public static final AuthHandler INSTANCE = new AuthHandler();

    private AuthHandler() {
    }

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        if (!SessionUtil.hasLogin(ctx.channel())) {
            ctx.channel().close();
        } else {
            // 已登录channel 后续数据不再校验
            ctx.pipeline().remove(this);
            super.channelRead(ctx, msg);
        }
    }
}
