package com.dzdy.dim.handler;

import com.dzdy.dim.protocol.request.ConfirmRequestPacket;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

/**
 * 消息确认请求处理器
 *
 * @author : wangzhiyong
 * @date : 2019/5/28 13:49
 * description :
 */
@Slf4j
@ChannelHandler.Sharable
public class ConfirmRequestHandler extends SimpleChannelInboundHandler<ConfirmRequestPacket> {

    public static final ConfirmRequestHandler INSTANCE = new ConfirmRequestHandler();

    private ConfirmRequestHandler() {
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, ConfirmRequestPacket packet) throws Exception {
        log.info("messageId:{} is consumed", packet.getPacketId());
    }
}
