package com.dzdy.dim.handler;

import com.dzdy.dim.contants.Session;
import com.dzdy.dim.protocol.request.HeartBeatRequestPacket;
import com.dzdy.dim.protocol.response.HeartBeatResponsePacket;
import com.dzdy.dim.util.SessionUtil;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.SimpleChannelInboundHandler;
import lombok.extern.slf4j.Slf4j;

/**
 * 心跳检查请求处理器
 *
 * @author : wangzhiyong
 * @date : 2019/5/28 11:21
 * description :
 */
@Slf4j
@ChannelHandler.Sharable
public class HeartBeatRequestHandler extends SimpleChannelInboundHandler<HeartBeatRequestPacket> {
    public static final HeartBeatRequestHandler INSTANCE = new HeartBeatRequestHandler();

    private HeartBeatRequestHandler() {
    }

    @Override
    protected void channelRead0(ChannelHandlerContext ctx, HeartBeatRequestPacket msg) {
        Session session = SessionUtil.getSession(ctx.channel());
        if (null != session) {
            log.info(" receive [user:{} - session:{}] heartBeat", session.getUserId(), session.getSessionId());
        }
        ctx.writeAndFlush(new HeartBeatResponsePacket());
    }
}
