package com.dzdy.dim.util;

import com.dzdy.dim.contants.Session;
import com.dzdy.dim.protocol.SockData;
import com.dzdy.dim.protocol.command.Command;
import io.netty.channel.Channel;
import lombok.extern.slf4j.Slf4j;

/**
 * 推送工具
 *
 * @author : wangzhiyong
 * @date : 2019/5/30 10:25
 * description :
 */
@Slf4j
public class PushUtil {

    /**
     * 发送消息
     *
     * @param session
     * @param data
     */
    public static void push(Session session, Command command, Object data) {
        SockData<Object> sockData = SockData.newData(command, data);
        Channel channel = SessionUtil.getChannel(session.getSessionId());
        if (null != channel) {
            channel.writeAndFlush(sockData).addListener(future -> {
                if (future.isSuccess()) {
                    log.info("sessionId:{} - messageId:{} push success.", session.getSessionId(), sockData.getId());
                } else {
                    log.error("sessionId:{} - messageId:{} push failure.", session.getSessionId(), sockData.getId());
                }
            });
        } else {
            log.error("push failure: can`t find sessionId.");
        }
    }
}
